var bricks = window.bricks || {}
bricks.Camera = class extends bricks.Popup {
	/*
	{
		fps:60
	}
	*/
	constructor(opts){
		opts.fps = opts.fps || 60;
		super(opts);
		this.stream = null;
		this.video = document.createElement('video');
		var filler = new bricks.Filler({});
		var hbox = new bricks.HBox({
				cheight:2
		});
		this.add_widget(filler);
		this.add_widget(hbox);
		var shot_btn = new bricks.Icon({
			url:bricks_resource('imgs/camera.png'),
			rate:1.5
		});
		var del_btn = new bricks.Icon({
			url:bricks_resource('imgs/delete.png'),
			rate:1.5
		})
		del_btn.bind('click', this.dismiss.bind(this));
		shot_btn.bind('click', this.take_picture.bind(this));
		this.imgw = new bricks.Image({
			width:'100%'
		});
		hbox.add_widget(shot_btn);
		hbox.add_widget(del_btn);
		filler.add_widget(this.imgw);
		this.task_period = 1 / this.fps;
    	schedule_once(this.startCamera.bind(this), 0.3);
	}
    async startCamera() {
		await bricks.app.start_camera();
		this.stream = bricks.app.video_stream;
		this.video.srcObject = this.stream;
		this.video.play();
		this.task = schedule_once(this.show_picture.bind(this), this.task_period);
    }
	show_picture(){
		var canvas = document.createElement('canvas');
        canvas.height = this.video.videoHeight;
        canvas.width = this.video.videoWidth;
		const context = canvas.getContext('2d');
        context.drawImage(this.video, 0, 0);
		this.imgw.set_url(canvas.toDataURL('image/jpeg'));
		this.task = schedule_once(this.show_picture.bind(this), this.task_period);
	}
	take_picture(){
		if (this.task){
			this.task.cancel();
			this.task = null;
		}
		var d = this.imgw.base64();
		this.dispatch('shot', d);
        // Create a blob from the canvas data URL
	}
}

bricks.Factory.register('Camera', bricks.Camera);
